from machine import Pin,I2C
import time
import network
from umqtt.simple import MQTTClient

wlan = network.WLAN(network.STA_IF)
wlan.active(True)
wlan.connect('CLSLabs', 'clshawks')

time.sleep(3)


print('Connected:', wlan.isconnected())

client = MQTTClient('fabstudent', 'mqtt.fabcloud.org', port=1883, user='fabacademy', password='fabacademy', keepalive=3600)

client.connect()

i2c_interface=1
sda_pin=Pin(26)
scl_pin=Pin(27)


try:
    i2c= I2C(i2c_interface, sda=sda_pin, scl=scl_pin, freq=115200)
    print('sucess')
except:
    print('error')

devices=i2c.scan()

if len(devices) == 0:
    print("No i2c device !")
else:
    print('i2c devices found:', len(devices))
    for device in devices:
        print("I2C hexadecimal address: ", hex(device))
        
while True:
    msg=i2c.readfrom(9,1)
    value=(int.from_bytes(msg, "big"))
    print(value)
    client.publish('fabacademy', str(msg))
    time.sleep(1)
    sda_pin.value(255)
    print("on")
    time.sleep(1)
    scl_pin.value(255)
    time.sleep(1)
    