from machine import Pin,I2C
import network
import time
from time import sleep_us
from umqtt.simple import MQTTClient
from machine import ADC

i2c_interface=0
sda_pin=Pin(20)
scl_pin=Pin(21)
ledpin = Pin(13, Pin.OUT)
TLE493D=0x35
overallx=0
overally=0
overallz=0
nomqtt=False
on=False

wlan=network.WLAN(network.STA_IF)
wlan.active(True)

try:
    wlan.connect('CLSLabs', 'clshawks')
    print(wlan.isconnected())
except:
    print("Problem connecting to the Wi-Fi")
    nomqtt=True
    
if nomqtt==False:
    try:
        client= MQTTClient('davidvaughn', 'mqtt.fabcloud.org', port=1883, user='fabacademy', password='fabacademy', keepalive=7200)
        client.connect()
        print("Connected to MQTT broker")
    except:
        print("Problem connecting to MQTT")


try:
    i2c= I2C(i2c_interface, sda=sda_pin, scl=scl_pin, freq=400000)
    print('success')
except:
    print('error')

devices=i2c.scan()
address=0x35

if len(devices) == 0:
    print("No i2c device !")
    
else:
    print('i2c devices found:', len(devices))
    for device in devices:
        print("I2C hexadecimal address: ", hex(device))
        
i2c.writeto(address, bytes([0xFF]))
i2c.writeto(address, bytes([0xFF]))
i2c.writeto(address, bytes([0x00]))
i2c.writeto(address, bytes([0x00]))
sleep_us(50)


# Configure TLE493D
i2c.writeto(address, bytes([0x10, 0x28]))
i2c.writeto(address, bytes([0x11, 0x15]))

def xyz():
    global on
    overallx=0
    overally=0
    overallz=0
    for i in range(1000):
    #data=i2c.readfrom_mem(0x35, 0x00, 1)
        data = i2c.readfrom(address, 6)
    #print(data)
        x = (data[0] << 4)+((data[4] & 0xF0) >> 4)
        y = (data[1] << 4)+(data[4] & 0x0F)
        z = (data[2] << 4)+(data[5] & 0x0F)
    #data=int.from_bytes(data, 'little')
        if (x > 2047):
          x = x-4096
        if (y > 2047):
          y = y-4096
        if (z > 2047):
          z = z-4096
        overallx+=x
        overally+=y
        overallz+=z
        time.sleep(0.001)
    x=overallx/1000
    y=overally/1000
    z=overallz/1000
    print(x, y, z)
    if abs(z)>500:
        if on==False:
            client.publish('fabacademy', 'on')
            on = True
            time.sleep(2)
            ledpin.value(1)
        else:
            client.publish('fabacademy', 'off')
            
    #client.publish('fabacademy', str(x))
    #time.sleep(.01)
    #client.publish('fabacademy', str(y))


time.sleep(1)

while True:
    xyz()
    